#include <iostream>
#include <stdio.h>
#include <algorithm>
using namespace std;

int main() {
    
 int T, N, M;
 long A[75000],B[75000];
 int niz[5];
 int d=0;
    cin >> T;
    for(int p=0;p<T;p++){
        cin >> N >> M;
        for(int i=0;i<N;i++)cin >> A[i];
        for(int i=0;i<M;i++)cin >> B[i];
        sort(&A[0],&A[N]);
        sort(&B[0],&B[M]);
        int k=0;
        int X=A[k+1]-A[k];
        int pom=1;
        for(int i=1;i<N-1;i++){
            if((A[i+1]-A[i])%X!=0)pom++;
        }
        for(int i=0;i<M;i++){
            if((B[i]-A[0])%X==0)pom++;
        }
        if(pom==1)niz[d]=1,d++;
        else niz[d]=0,d++;
        
    }
    for(int i=0;i<d;i++)cout << niz[i] << endl;
    

    return 0;
}